<?PHP

// cycle thru the servers

$serverlist = array_merge($MyToppies,$RECservers) ;
$events = array() ;

foreach ($serverlist as $servername)
{
 // Make sure the view key exists - initialise if necessary
 if(!array_key_exists($servername,$expand_server)) { $expand_server[$servername] = is_true($TFexpandServer[$servername],"y","n") ; }
 
 ini_set("display_errors",0) ; 
 $use_cache[$servername] = false ;
 $cache = array() ;
 if($force_cache)
 {
  $server_error[$servername] = "Force cache usage" ;
	$ftp = false ;
	$use_cache[$servername] = true ;
 }
 else
 {
  echo "<!-- Starting $servername -->\n" ;
  if(!($ftp=ftp_connect($FTPaddress[$servername],$FTPport[$servername]))) 
  {
   $server_error[$servername] = "Cannot connect to ".$FTPaddress[$servername]."!" ;
	 $use_cache[$servername] = true ;
   echo "<!-- ".$server_error[$servername]." -->\n" ;
   //continue ; 
  }
  echo "<!-- Logging in to $servername -->\n" ;
  if(!ftp_login($ftp,$FTPuser[$servername],$FTPpw[$servername]))
  {
   $server_error[$servername] = "Cannot login to ".$FTPaddress[$servername]."!" ;
   ftp_close($ftp) ;
	 $ftp = false ;
	 $use_cache[$servername] = true ;
   //continue ; 
  }
	else
	{
   ftp_chdir($ftp,"/") ;
   // Now get some info about the FTP server
   $rows = array() ; 
   if ( version_compare(phpversion(),"5.0.0")>=0 )
   {
    $rows = ftp_raw($ftp,"STAT") ;
    foreach($rows as $key => $line)
    {
     //echo "$servername $key = $line\n" ;
     echo "<!-- raw => ".$line." -->\n" ;
	   $line = trim($line) ;
	   if(substr($line,0,3)=="500") {}  // This ftp server does not understand STAT
	   if(substr($line,0,3)=="211") {}  // This ftp server does understand STAT
	   if(substr($line,0,20)=="ftpd (Topfield ftpd)") { $FTPversion[$servername]=substr($line,21) ; }  // ftpd-topfield version
	   if(substr($line,0,9)=="HDD Free ") {}  // HDD freespace
	   if(substr($line,0,9)=="HDD Total") { $MyToppyHDD[$servername] = substr($line,10,9)*1024 ; }  // HDD total size
	   if($line == "Unable to get HDD size info" ) 
	   {
      $server_error[$servername] = $FTPaddress[$servername]." cannot connect to Topfield PVR!" ;
      ftp_close($ftp) ;
	    $ftp = false ;
	    $use_cache[$servername] = true ;
	   }
    }
	 }
  }
 }
 $extended_list = array() ;

 $cache = unserialize(file_get_contents($local_files.DIRECTORY_SEPARATOR.$servername."_files_cache")) ;
 echo "<!-- Read cache => ".$local_files.DIRECTORY_SEPARATOR.$servername."_files_cache"." -->\n" ;
 
 ini_set("display_errors",1) ;
 
 //print_r($cache) ;
 if($use_cache[$servername])
 {
  //$cache = unserialize(file_get_contents($local_files.DIRECTORY_SEPARATOR.$servername."_files_cache")) ;
	if(is_array($cache))
	{ 
	//print_r($cache) ;
  $serverfiles[$servername]        = $cache["files"]  ;
  $serversizes[$servername]        = $cache["sizes"]  ;
  $serverfolders[$servername]      = $cache["list"]   ;
  $serverRec1[$servername]         = $cache["rec1"]   ;
  $serverRec2[$servername]         = $cache["rec2"]   ;
  $serverPlay[$servername]         = $cache["play"]   ;
  $server_active_rec[$servername]  = $cache["f_a_r"]  ;
  $server_active_play[$servername] = $cache["f_a_p"]  ;
  $server_is_rec[$servername]      = $cache["f_i_r"]  ;
  $server_extn[$servername]        = $cache["fextn"]  ;
	}
	else
	{
	 $use_cache[$servername] = false ;
	 // create an empty cache
	 $cache = array() ;
	 $cache["dirlist"] = array() ;
	}
	if ($ftp) { ftp_close($ftp) ; $ftp = false ;}
	continue;
 }
 
 // Now read the recplay file if it exists
 $rec1 = $rec2 = $play = array("","","","","") ;
 //label <tab> filename <tab> channel <tab> start <tab> duration
 if (in_array($servername, $MyToppies))
 {
	$play = $rec2 = $rec1 = array("REC1","","","",""."") ;
	$rec2[0] = "REC2" ;
	$play[0] = "PLAY" ;
  ini_set("display_errors",0) ; 
  echo "<!-- Getting REC/PLAY for $servername -->\n" ;
  if(ftp_chdir($ftp,$epg_recplay_rem))
	{ 
   if(ftp_size($ftp,$epg_recplay)>0)
   {
 	  $get = ftp_get($ftp,$epg_recplay_loc.DIRECTORY_SEPARATOR.$epg_recplay,$epg_recplay,FTP_BINARY);
 	  $rows = file($epg_recplay_loc.DIRECTORY_SEPARATOR.$epg_recplay);
	  //if($cache_enabled) { $i = file_put_contents($local_files.DIRECTORY_SEPARATOR.$servername."_recplay_cache",serialize($rows)) ; }
	
	  //echo $rows[0]."<br>\n" ;
	  $rec1 = explode("\t",$rows[0]); //$rec1[1] = $data_files."/".rec1[1] ;
	  $rec2 = explode("\t",$rows[1]); //$rec2[1] = $data_files."/".rec2[1] ;
	  $play = explode("\t",trim($rows[2]));		 
	 }
	}
 ini_set("display_errors",1) ; 
 }

 //echo "<b>Current directory is $currentdir</b>\n";
 
 $folderlist = array() ;
 $folderfiles = array() ;
 $foldersizes = array() ;
 
 $folderlist[1] = $TFdatafiles[$servername] ;   // starting point
 
 $foldernum = 1 ;

 //echo "<br>\n" ;
 while ( array_key_exists($foldernum, $folderlist) ) 
 {  
  if(trim(substr($expand_server[$servername],$foldernum,1))=="") { $expand_server[$servername] = substr_replace( str_pad($expand_server[$servername],$foldernum+1) , is_true($TFexpandFolders[$servername],"y","n") , $foldernum , 1 ) ; }
  $currentdir = $folderlist[$foldernum] ;
  echo "<!-- Folder $servername => $currentdir -->\n" ;
  //echo "folder = $servername/$currentdir\n" ;
	$foldersizes[$currentdir] = 0.0 ;
	//echo "chdir=$currentdir<br>\n" ;
  ini_set("display_errors",0) ; 
  if(ftp_chdir($ftp,$currentdir)) 
	{
	 $rows = ftp_rawlist($ftp,"");
	 echo "<!-- Read $servername $currentdir ".count($rows)." files -->\n" ;
	 $foldercache[$currentdir] = false ;
	 //print_r($rows) ;
	}
	elseif(array_key_exists($currentdir,$cache["dirlist"]))
	{
	 $foldererror[$currentdir] = "Folder $currentdir does not exist" ;
	 echo "<!-- $servername ".$foldererror[$currentdir]." (using cache) -->\n" ;
	 $foldercache[$currentdir] = true ;
	 $rows = $cache["dirlist"][$currentdir] ;
	 //echo "Cache $servername $currentdir\n" ;
	 //print_r($cache["dirlist"][$currentdir]) ;
	 //print_r($rows) ;
	}
	else
  {
   $server_error[$servername] = "Folder $currentdir does not exist!" ;
	 echo "<!-- $servername ".$foldererror[$currentdir]." -->\n" ;
	 $foldercache[$currentdir] = true ;
	 $rows = false ;
	 //echo "No $servername $currentdir\n" ;
	 //print_r($cache["dirlist"][$currentdir]) ;
	 $foldernum += 1 ;
	 continue;
	}
	
	$files = array() ;
	
	//echo "<!-- ";print_r($rows);echo " -->\n";
	foreach ($rows as $index => $line)
	{
	 //echo "$servername $line\n" ;
	 //echo "<!-- File => $line  -->\n" ;
	 //$x = preg_replace("/ +/","|",$line) ;
	 //echo "<!-- File => $x  -->\n" ;
	 $f = preg_split("/ +/",$line,9,PREG_SPLIT_NO_EMPTY) ;
	 //echo "<!-- ";print_r($f);echo " -->\n";
	 list($rights,$x,$u1,$u2,$size,$month,$day,$time,$name) = $f ;
	 //echo "<!-- File $name => $rights  -->\n" ;
	 list($size) = sscanf($size,"%f") ;
	 $name = trim($name) ;
	 //echo "$size $name\n" ;
	 if(substr($rights,0,1)=="d")
	 {
	  if ( $name<>".." and $name<>"." ) 
		{ 
		 $folderlist[] = $currentdir."/".$name ; 
		 //echo "found ".$currentdir."/".$name."<br>\n" ;
		}
	 }
	 else
	 {
	  $orig_name = $name ;
		//$time = (substr_count(":",$time)==99) ? $time : date("Y")." $time" ;
		if (strlen($time)==5) { $time = date("Y")." $time" ; }
		$dt = date("Ymd h:i", ((($i = strtotime("$day $month $time")) < time()) ? $i : strtotime("$day $month $time last year")));
		//echo "time= $day $month $time $orig_name<br>\n" ;
		//echo "time=$dt  $day $month $time $orig_name<br>\n" ;
		
	  if ( $thisfile_is_rec=(substr(strtolower($line),-4)==".rec") ) 
		{
		 $extn = substr($line,-4) ;
		 $line = substr($line,0,-4) ; 
		} 
	  if ( $thisfile_is_rec=(substr(strtolower($name),-4)==".rec") ) 
		{
		 $extn = substr($name,-4) ;
		 $name = substr($name,0,-4) ; 
		} 
		//echo "$orig_name ".$play[1]."<br>\n" ;
		 
	  $filename = $name ;
		if (!isset($expand_file[$servername.$currentdir."/".$filename])) { $expand_file[$expand_file[$servername.$currentdir."/".$filename]] = "n" ; }
		$file_active_rec[$filename]  = ( ($orig_name==$rec1[1] or $orig_name==$rec2[1]) and $currentdir=$data_files ) ;
		$file_active_play[$filename] = ( $orig_name==$play[1] ) ;
		$file_is_rec[$filename] = $thisfile_is_rec ;
		$file_extn[ $filename ] = $extn ;
		if ($set_file_sort=="date") { $x = "$dt\t$filename" ; }
		else { $x = strtolower($filename)."\t$filename" ; }
		$files[ $x ] = $line ;
	  $foldersizes[$currentdir] += $size ;
		//echo "file = $servername/$currentdir/$filename\n" ;
		
		if ($thisfile_is_rec and !$file_active_rec[$filename])
		{
		 // only add REC files to the extended list
		 $extended_list["$currentdir/$filename"] = "ftp://".$FTPuser[$servername].":".$FTPpw[$servername]."@".$FTPaddress[$servername].":".$FTPport[$servername]."$currentdir/$orig_name" ;
		}
	  //echo "$filename=".$file_active_play[$filename]."<br>\n" ;
	 }
	}
	ksort($files);	
  ini_set("display_errors",1) ; 
	$folderfiles[$currentdir] = $files ;
	$folderrows[$currentdir] = $rows ;
	//echo "There are ".count($files)." recordings in $currentdir.<br>\n";	
	$foldernum += 1 ;
	//echo "<br><br>\n";
 }
	//echo "There are ".count($folderfiles)." folders.<br>\n";	
 //echo "<br><br>\n";
                                    $cache["dirlist"] = $folderrows ;
 $serverfiles[$servername]        = $cache["files"]   = $folderfiles ;
 $serversizes[$servername]        = $cache["sizes"]   = $foldersizes ;
 $serverfolders[$servername]      = $cache["list"]    = $folderlist ;
 $serverRec1[$servername]         = $cache["rec1"]    = $rec1 ;
 $serverRec2[$servername]         = $cache["rec2"]    = $rec2 ;
 $serverPlay[$servername]         = $cache["play"]    = $play ;
 $server_active_rec[$servername]  = $cache["f_a_r"]   = $file_active_rec ;
 $server_active_play[$servername] = $cache["f_a_p"]   = $file_active_play ;
 $server_is_rec[$servername]      = $cache["f_i_r"]   = $file_is_rec ;
 $server_extn[$servername]        = $cache["fextn"]   = $file_extn ;
 $server_foldercache[$servername]                     = $foldercache ;
 
 ftp_close($ftp) ; $ftp = false ;
 
 if($cache_enabled) { $i = file_put_contents($local_files.DIRECTORY_SEPARATOR.$servername."_files_cache",serialize($cache)) ; }
 $full_extended_list[$servername] = $extended_list ;
 echo "<!-- End of $servername loop -->\n" ;
} // end of server loop

?>
