<?php
/*
Copyright (c) 2006, John Stevens
All rights reserved.
E-mail : john AT jstevens DOT com

Non-commercial redistribution and use, with or without modification, 
is permitted provided that the following conditions are
met:

    * Redistributions must retain the above copyright
      notice, this list of conditions and the following disclaimer.

    * The name of John Stevens may not
      be used to endorse or promote products derived from this
      software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, 
THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; 
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED 
AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, 
OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, 
EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/
?>
<?php include_once("config_ini.php") ; ?>
<?php include_once("version.php") ; ?>
<html>
<head>
  <title>Toppy-Web Timers <?=$version?></title>
	<script src='timers.js' type="text/javascript"></script>
	<script src='cookies.js' type="text/javascript"></script>
  <style type="text/css">
    @import "toppy-web.css";
  </style>

<script language="JavaScript"  type="text/javascript">
<!--
var number_days, default_duration, default_padding, hour_height, screen_width, set_scroll, mouseover_compare_inner ;

function initialise_defaults() {

 theForm          = document.getElementById("form_js") ;
 number_days      = theForm.number_days.value ;
 default_duration = theForm.default_duration.value ;
 default_padding  = theForm.default_padding.value ;
 hour_height      = theForm.hour_height.value ;
 screen_width     = theForm.screen_width.value ;
 set_scroll       = theForm.set_scroll.value ;
 mouseover_compare_inner = (theForm.mouseover_compare_inner.value=="Yes") ;
 
}
//-->

</script>
</head>

<body onLoad="initialise_defaults();" bgcolor='#003366'>

<form name="form_js" id="form_js" style="display:none;" action="">
<input type="hidden" name="number_days" value="<?=$number_days?>">
<input type="hidden" name="default_duration" value="<?=$default_duration?>">
<input type="hidden" name="default_padding" value="<?=$default_padding?>">
<input type="hidden" name="hour_height" value="<?=$hour_height?>">
<input type="hidden" name="screen_width" value="<?=$screen_width?>">
<input type="hidden" name="mouseover_compare_inner" value="<?=yes_if_true($mouseover_compare_inner)?>">
<input type="hidden" name="set_scroll" value="<?=($set_scroll=trim($_POST["set_scroll"]))?>">
</form>

<?php include "links.php"; ?>

<?PHP
  //print_r($_COOKIE) ;
  //print_r($chn_names) ;
 	$set_action       = stripslashes($_POST["set_action"]);
 	$set_server       = stripslashes($_POST["set_server"]);
 	$set_line         = stripslashes($_POST["set_line"]);
 	$set_filename     = stripslashes($_POST["set_filename"]);
 	$set_channel      = stripslashes($_POST["set_channel"]);
 	$set_start        = stripslashes($_POST["set_start"]);
 	if(($set_duration = stripslashes($_POST["set_duration"])) == "") { $set_duration=$default_duration; }
 	if(($set_padding  = stripslashes($_POST["set_padding"])) == "")  { $set_padding="Y"; }
	
 	$set_newname          = stripslashes($_POST["set_newname"]);
 	$set_newchannel       = stripslashes($_POST["set_newchannel"]);
 	$set_newstart         = stripslashes($_POST["set_newstart"]);
 	if (($set_newduration = stripslashes($_POST["set_newduration"])) == "") { $set_newduration=$default_duration; }
 	if (($set_newpadding  = stripslashes($_POST["set_newpadding"])) == "")  { $set_newpadding=$default_padding; }
	
	$expand_server  = isset($_COOKIE["timers_expand_server"]) ? $_COOKIE["timers_expand_server"] : array() ;
	
	if ($demo_mode) { unset($set_action) ; }  // discard any action in demo mode
	
if (!$force_cache)
{		
 // first see if any servers need waking
 foreach ($MyToppies as $servername)
 {	
  wake_server($servername) ;
  // Make sure the view key exists - initialise if necessary
  if(!array_key_exists($servername,$expand_server)) { $expand_server[$servername] = is_true($TFexpandServer[$servername],"yyy","nyy") ; }
 }
}

echo "<script language='JavaScript' type='text/javascript'>\n";
echo "<!--\n";
foreach($expand_server as $key => $value)
{
 echo "SetCookie( 'timers_expand_server[$key]', '$value') ;\n" ;
}
echo "//-->\n";
echo "</script>\n";
?>
<script language='JavaScript' type="text/javascript">
<!--
openImage       = new Image(16,16) ;
closedImage     = new Image(16,16) ;
openImage.src   = "minus.gif" ;
closedImage.src = "plus.gif" ;
//-->
</script>
<?PHP
		 
  if($set_action == "Delete" or $set_action == "Add" or $set_action == "Edit")
  {
   $ftp=ftp_connect($FTPaddress[$set_server],$FTPport[$set_server]) ;
	 ftp_login($ftp,$FTPuser[$set_server],$FTPpw[$set_server]) ;
   ftp_chdir($ftp,$TFepgdata[$set_server] );
	 if(ftp_size($ftp,$set_timers_tgd)>0)
	 {
	  $get = ftp_get($ftp,$set_timers_loc.DIRECTORY_SEPARATOR.$set_timers_tgd,$set_timers_tgd,FTP_BINARY);	 
  	$fp  = fopen ($set_timers_loc.DIRECTORY_SEPARATOR.$set_timers_tgd, "a");
	 }
	 else
   {
	  $fp = fopen ($set_timers_loc.DIRECTORY_SEPARATOR.$set_timers_tgd, "w");
	 }
	
   if($set_action=="Delete")
   {
	  $values = explode("\t",$set_line);
	  //if($TFuseLCN[$set_server])
	  //{
	  //	$set_channel=array_search($values[1],$lcn_chn_trans);
	  //}
	  //else
	  //{
	  //	$set_channel=$chn_names[$values[1]];
	  //}
	  $set_channel=$chn_names[$values[1]];
      $set_start = substr($values[3],0,4)."-".substr($values[3],4,2)."-".substr($values[3],6,2)." ".substr($values[3],9,5);
	  $set_duration = $values[4];
	  $set_filename = substr_replace($values[0],"",-4);
	  $set_padding = "D";
	  // Delete the old timer
	  fwrite($fp,tf_request_channel($set_server,$set_channel)."\t".$set_start."\t".$set_duration."\t".$set_filename."\t\t\t\tD\t\n");
	 }
   else if($set_action=="Edit")
	 {
	  // Delete the old timer
	  //if($TFuseLCN[$set_server])
	  //{
	  //	fwrite($fp,array_search($set_channel,$lcn_chn_trans)."\t".$set_start."\t".$set_duration."\t".$set_filename."\t\t\t\tD\t\n");
	  //}
	  //else
	  //{
	  //  fwrite($fp,$set_channel."\t".$set_start."\t".$set_duration."\t".$set_filename."\t\t\t\tD\t\n");
	  //}
	  fwrite($fp,tf_request_channel($set_server,$set_channel)."\t".$set_start."\t".$set_duration."\t".$set_filename."\t\t\t\tD\t\n");
	 }
	 if($set_action=="Add" or $set_action=="Edit")
	 {
	  // Add the new timer
	  //if($TFuseLCN[$set_server])
	  //{
	  //	fwrite($fp,array_search($set_newchannel,$lcn_chn_trans)."\t".$set_newstart."\t".$set_newduration."\t".$set_newname."\t\t\t\t".$set_newpadding."\t\n");
	  //}
	  //else
	  //{
	  //  fwrite($fp,$set_newchannel."\t".$set_newstart."\t".$set_newduration."\t".$set_newname."\t\t\t\t".$set_newpadding."\t\n");
	  //}
	  
	  fwrite($fp,tf_request_channel($set_server,$set_newchannel)."\t".$set_newstart."\t".$set_newduration."\t".$set_newname."\t\t\t\t".$set_newpadding."\t\n");
	 }
	 fclose($fp);
	 ftp_put($ftp,$set_timers_tgd,$set_timers_loc.DIRECTORY_SEPARATOR.$set_timers_tgd,FTP_BINARY);
	 ftp_close($ftp) ;
  }
	
	
	
?>




<div id="div_list" style="z-index: 4; width: 800px;">
<form name="form_list" id="form_list" method="POST" action="<?=$_SERVER['SCRIPT_NAME']?>">

<input type="hidden" name="set_action" value="none">
<input type="hidden" name="set_filename" value="">
<input type="hidden" name="set_directory" value="">
<input type="hidden" name="set_server" value="">
<input type="hidden" name="set_line" value="">


<?PHP

	 include "get_timer_lists.php" ;
	 
	 //
	 //
	 // Completed fetching the timers
	 //
	 // Now start displaying them
	 //
	 //
	 //	
	 
?>

<table class='table_outer' cellspacing='2'>
 <tr>
  <td>
   <table class='table_server' id='table_server_0' cellspacing='0'>
    <tr class='server_row'>
     <td class='fcol_header'>
      Topfield Timers&nbsp;
      <input type='button' value='Refresh the display' onClick='click_refresh(this.form);'>&nbsp;&nbsp;
			<?PHP
			foreach ($MyToppies as $servername)
			{
			 //if ( !$use_cache[$servername] && !$server_error[$servername] )
			 if ( !$server_error[$servername] ) // Look for any accessible servers
			 {
			  // if one is found then the "Add Timer" button can be displayed
			  echo "<input type='button' value='Add&nbsp;&nbsp;timer' onClick='click_add(event);'>\n" ;
				break ;
			 }	 
			}
			?>
     </td>
    </tr>
	  <!-- Ignore this block for the moment but leave in case I decide to add something here
    <tr>
		 <td>
     <div id='div_server_0' style='display:block'>
      <table class='table_server_content' cellspacing='0'>
       <tr>
	      <td colspan=99>
         <table class='table_folder' id='table_folder_0_0' cellspacing='0'>
          <tr id='folder0' class='directory_row' style='display:table-row;'>
	         <td class='fcol_sort'></td>
	        </tr>
				 </table>
        </td>
       </tr>
      </table>
		 </div>
     </td>
    </tr>		
	  -->
	 </table> 
<?PHP
	
  $servernum = 0;
  foreach ($MyToppies as $servername)
	{ 
	 $servernum++ ;
	 
	 if ($use_cache[$servername]) { $cache = unserialize(file_get_contents($local_files.DIRECTORY_SEPARATOR.$servername."_timers_cache")) ; }
	 else                         { $cache = $server_cache[$servername] ; }
	 
	 if ( !is_array($cache) ) { $use_cache[$servername] = false ; } // No cache exists
	 
	 $types = $cache["pend_types"] ;
	 $pending_timers = $cache["pend_timers"] ;
	 $timers = $cache["current_timers"] ;
	 $rec1 = $cache["rec1"] ;
	 $rec2 = $cache["rec2"] ;
	 $types["***|dummy|/***"] = "" ; // ensure at least one entry exists
	 $pend_status = count(array_keys($types,"Delete"))." deletions and ".count(array_keys($types,"Add"))." additions pending" ;
	 //print_r($pending_timers) ;
	 
   if(substr($expand_server[$servername],0,1)=="y")
   {
    $is_expand = "block" ;
    $image = "minus.gif" ;
   }
   else
   {
    $is_expand = "none" ;
    $image = "plus.gif" ;
   }
	
   if($server_error[$servername] && !$use_cache[$servername])
   {
?>
    <tr><td>
    <!-- start of server table <?=$servername?> -->
    <table class='table_server' id='table_server_<?=$servernum?>' cellspacing='0'>
    <tr class='server_row'>
    <td class='fcol_first'></td>
    <td class='fcol_server' colspan='2'><?=$servername?></td>
    <td class='fcol_error' colspan='5'><?=$server_error[$servername]?></td>
    </tr>

    <tr><td colspan=99>
    <div id='div_server_<?=$servernum?>' style='display:<?=$is_expand?>;'>
    <!-- start of server content table <?=$servername?> -->
    <table class='table_server_content' cellspacing='0'>
<?PHP
   }
   else
   {
?>
    <tr><td>
    <!-- start of server table <?=$servername?> -->
    <table class='table_server' id='table_server_<?=$servernum?>' cellspacing='0'>
    <tr class='server_row' onMouseOver='highlight_server(this,<?=$servernum?>);' onMouseOut='lowlight_server(this,<?=$servernum?>);' onClick='click_server(this,<?=$servernum?>,"<?=$servername?>");'>
    <td class='fcol_first'><img id='img_server_<?=$servernum?>' src='<?=$image?>' alt=''></td>
    <td class='fcol_server'><?=$servername?></td>
    <td class='tcol_msg' colspan='5'><?=("There are ".count($timers)." current timers and ".count($pending_timers)." pending timers")?></td>
    </tr>
<?PHP		
    if($use_cache[$servername] and !$demo_mode)
    {
     echo "<tr><td colspan=7 align='center'><div class='fcol_warn'>Using cache (".$server_error[$servername].")</div></td></tr>\n" ;
    }
?>
    <tr><td colspan=7>
    <div style='width:810px; height:0px; overflow:hidden;'><!-- --></div>
    <div id='div_server_<?=$servernum?>' style='display:<?=$is_expand?>;'>
    <!-- start of server content table <?=$servername?> -->
    <table class='table_server_content' cellspacing='0'>

<?PHP
    $foldernum = 1 ;  // Current timers folder
    $folder_id = $servernum."_".$foldernum ;
	
    if(substr($expand_server[$servername],$foldernum,1)=="y")
    {
     $is_expand = "block" ;
     $image = "minus.gif" ;
    }
    else
    {
     $is_expand = "none" ;
     $image = "plus.gif" ;
    }

    echo "<tr><td>\n";
    echo "<!-- start of folder table $servername -->\n" ;
    echo "<table class='table_folder' id='table_folder_".$folder_id."' cellspacing='0'>\n";
    if ( count($timers)==0 and !is_array($rec1) and !is_array($rec2) )
    {
     echo "<tr id='folder$foldernum' class='directory_row' style='display:table-row;'>\n";
     echo "<td class='fcol_first'></td>\n";
    }
    else
    {
     echo "<tr id='folder_$folder_id' class='directory_row' style='display:table-row;' onMouseOver='highlight_folder(this,$servernum,$foldernum);' onMouseOut='lowlight_folder(this,$servernum,$foldernum);' onClick='click_folder(this,$servernum,$foldernum,\"$servername\");'>\n";
     echo "<td class='fcol_first'><img id='img_folder_$folder_id' src='$image' alt=''></td>\n";
    }
    echo "<td class='fcol_folder_name'>Current Timers</td>\n";
    echo "<td class='fcol_space'></td>\n";
    echo "<td class='tcol_msg' colspan=5>There are ".count($timers)." current timers</td>\n";
    echo "</tr>\n" ;
    echo "<tr><td colspan=8>\n";
    echo "<div style='display:block; width:797px; height:0px;'><!-- --></div>\n";
    echo "<div id='div_folder_$folder_id' style='display:$is_expand;'>\n";
    echo "<!-- start of folder content table $servername -->\n" ;
    echo "<table class='table_folder_content' cellspacing='0'>\n";


    // First read the recplay file if it exists and show any active recordings
    //$rec1 = $rec2 = $play = array("","","","","") ;
    //label <tab> filename <tab> channel <tab> start <tab> duration
	
    if (is_array($rec1))
    {
     //$filename,$channel,$lcn,$start,$duration,$restype,$svctype,$tuner,$namefix,$isrec,$lcn
     $row_class="active_row" ; 
     $dt = substr($rec1[3],0,4)."-".substr($rec1[3],4,2)."-".substr($rec1[3],6,2)." ".substr($rec1[3],9,5) ;
     $dt = date("D",strtotime($dt))." ".$dt ;
     $dt = str_replace(" ","&nbsp;",$dt) ;
     echo "<tr class='$row_class'>\n";
     echo "<td class='tcol_name'>".fix_chars(substr_replace($rec1[1],"",-4))."</td>\n";
     echo "<td>&nbsp;</td>\n";
     if($TFuseLCN[$servername])
	 {
	 	//echo "LCN ".$rec1[5]."=".$lcn_chn_trans[$rec1[5]]."\n" ;
		$chname = $lcn_chn_trans[$rec1[5]] ;
	 }
	 else
	 {
     	$chname = array_key_exists($rec1[2],$chn_names) ? $chn_names[$rec1[2]] : "<i>$rec1[2]</i>" ;
     }
     echo	"<td align='center'>$chname</td><td>&nbsp;</td>\n";
     echo	"<td align='right'>$dt</td><td>&nbsp;</td>\n";
     echo	"<td align='center'>Active</td><td>&nbsp;</td>\n";
     echo	"<td align='center'>".$rec1[4]."</td><td>&nbsp;</td>\n";
     echo	"<td class='timer_recording'><b>Recording</b></td></tr>\n";	      
    }
	
    //if ($rec2[1]<>"")
    if (is_array($rec2))
    {
     //$filename,$channel,$lcn,$start,$duration,$restype,$svctype,$tuner,$namefix,$isrec,$lcn
     $row_class="active_row" ; 
     $dt = substr($rec2[3],0,4)."-".substr($rec2[3],4,2)."-".substr($rec2[3],6,2)." ".substr($rec2[3],9,5) ;
     $dt = date("D",strtotime($dt))." ".$dt ;
     $dt = str_replace(" ","&nbsp;",$dt) ;
     echo "<tr class='$row_class'>\n";
     echo "<td class='tcol_name'>".fix_chars(substr_replace($rec2[1],"",-4))."</td>\n";
     echo "<td>&nbsp;</td>\n";
     if($TFuseLCN[$servername])
	 {
	 	//echo "LCN ".$rec2[5]."=".$lcn_chn_trans[$rec2[5]]."\n" ;
		$chname = $lcn_chn_trans[$rec2[5]] ;
	 }
	 else
	 {
     	$chname = array_key_exists($rec2[2],$chn_names) ? $chn_names[$rec2[2]] : "<i>$rec2[2]</i>" ;
     }
     echo	"<td align='center'>$chname</td><td>&nbsp;</td>\n";
     echo	"<td align='right'>$dt</td><td>&nbsp;</td>\n";
     echo	"<td align='center'>Active</td><td>&nbsp;</td\n";
     echo	"<td align='center'>".$rec2[4]."</td><td>&nbsp;</td>\n";
     echo	"<td class='timer_recording'><b>Recording</b></td></tr>\n";	      
    }


    $temp_dt = "" ;
    $row_class = "timer_row_1" ;
	
    foreach( $timers as $timer)
    {
     //$filename,$channel,$lcn,$start,$duration,$restype,$svctype,$tuner,$namefix,$isrec,$reserved,$lcn
     $values = explode("\t",$timer);
     $x = substr($values[3],0,8) ;
     //echo "\n$temp_dt=$x\n" ;
     if ($temp_dt <> $x)
     {
      $temp_dt = $x ;
      if ($row_class=="timer_row_1") { $row_class="timer_row_2" ; }
      else                           { $row_class="timer_row_1" ; }
     }
     $dt = substr($values[3],0,4)."-".substr($values[3],4,2)."-".substr($values[3],6,2)." ".substr($values[3],9,5) ;
     $dt = date("D",strtotime($dt))." ".$dt ;
     $dt = str_replace(" ","&nbsp;",$dt) ;
     if($TFuseLCN[$servername])
	 {
	 	//echo "LCN ".$values[11]."=".$lcn_chn_trans[$values[10]]." $timer\n" ;
		$chname = $lcn_chn_trans[$values[11]] ;
	 }
	 else
	 {
    	$chname = array_key_exists($values[1],$chn_names) ? $chn_names[$values[1]] : "<i>$values[1]</i>" ;
     }
		
     echo "<tr class='$row_class'>\n";
     echo "<td class='tcol_name'>".fix_chars(substr_replace($values[0],"",-4)).is_true($values[9]=="VCR Timer"," (VCR timer)","")."</td>\n";
     echo "<td>&nbsp;</td>\n";
     echo	"<td align='center'>".$chname."</td><td>&nbsp;</td>\n";
     echo	"<td align='right'>$dt</td><td>&nbsp;</td>\n";
     echo	"<td align='center'>".$values[5]."</td><td>&nbsp;</td>\n";
     echo	"<td align='center'>".$values[4]."</td><td>&nbsp;</td>\n";
     echo	"<td class='tcol_last'>\n";
		 if($use_cache[$servername] and !$demo_mode)
		 {
		  echo "<span class='file_cached'>Using cache</span>";
		 }
		 else
		 {
      if($values[9]=="Recording")
      {
       echo "<input type='button' value='Edit' onClick='click_edit(event,\"$servername\",\"".htmlentities(substr_replace($values[0],"",-4),ENT_QUOTES)."\",\"$chname\",\"".substr($values[3],0,4)."-".substr($values[3],4,2)."-".substr($values[3],6,2)." ".substr($values[3],9,5)."\",\"".$values[5]."\",\"".$values[4]."\",\"-00 +00\");'>\n";
      }
      echo "<input type='button' value='Delete' onClick='click_delete(this.form,\"$servername\",\"".htmlentities(substr_replace($timer,"",-2),ENT_QUOTES)."\",\"".htmlentities(substr_replace($values[0],"",-4),ENT_QUOTES)."\");'>\n";
		 }
     echo "</td></tr>\n";	      
    }

    echo "\n</table>\n";  // end of folder content table
    echo "<!-- end of folder content table $servername -->\n" ;
    echo "</div>\n";
    echo "</td></tr>\n";
    echo "</table>\n";  // end of folder table
    echo "<!-- end of folder table $servername -->\n" ;
	
    //
    //
    // Now start the pending timers
    //
    //
    $foldernum = 2 ;  // Current timers folder
    $folder_id = $servernum."_".$foldernum ;
	
    if(substr($expand_server[$servername],$foldernum,1)=="y")
    {
     $is_expand = "block" ;
     $image = "minus.gif" ;
    }
    else
    {
     $is_expand = "none" ;
     $image = "plus.gif" ;
    }
	
    echo "<tr><td>\n";
    echo "<!-- start of folder table $servername -->\n" ;
    echo "<table class='table_folder' id='table_folder_".$folder_id."' cellspacing='0'>\n";
    if(count($pending_timers)==0)
    {
     echo "<tr id='folder_$folder_id' class='directory_row' style='display:table-row;'>\n";
     echo "<td class='fcol_first'></td>\n";
    }
    else
    {
     echo "<tr id='folder$foldernum' class='directory_row' style='display:table-row;' onMouseOver='highlight_folder(this,$servernum,$foldernum);' onMouseOut='lowlight_folder(this,$servernum,$foldernum);' onClick='click_folder(this,$servernum,$foldernum,\"$servername\");'>\n";
     echo "<td class='fcol_first'><img id='img_folder_$folder_id' src='$image' alt=''></td>\n";
    }
		
    echo "<td class='fcol_folder_name'>Pending Timers</td>\n";
    echo "<td class='fcol_space'></td>\n";
    echo "<td class='tcol_msg' colspan=5>".$pend_status."</td>\n";
    echo "</tr>\n" ;
	
    echo "<tr><td colspan=8>\n";
    echo "<div style='display:block; width:797px; height:0px;'><!-- --></div>\n";
    echo "<div id='div_folder_$folder_id' style='display:$is_expand;'>\n";
    echo "<!-- start of folder content table $servername -->\n" ;
    echo "<table class='table_folder_content' cellspacing='0'>\n";
?>


<?PHP
		
	  foreach( $pending_timers as $index => $timer)
	  {
	   $values = explode("\t",$timer);
	   if($types[$index]=="Add") { $pclass = "timer_row_1" ; }
	   else                      { $pclass = "timer_row_2" ; }
	   echo "<tr class='$pclass'>\n";
	   echo "<td>".$types[$index]."</td>\n";
	   echo "<td>&nbsp;</td>";
	   echo "<td class='tcol_name'>".$values[3]."</td><td>&nbsp;</td>";
	   if($TFuseLCN[$servername])
	   {
			echo "<td align='center'>".$lcn_chn_trans[$values[0]]."</td>\n";
	   }
	   else
	   {
	    echo "<td align='center'>".$values[0]."</td>\n";
	   }
	   echo "<td>&nbsp;</td>";
	   echo "<td align='right'>".date("D",strtotime($values[1]))." ".$values[1]."</td>\n";
	   echo "<td>&nbsp;</td>";
	   echo "<td align='right'>".$values[2]."</td>\n";
	   echo "<td>&nbsp;</td>";
	   echo "<td align='right'>".$values[7]."</td>\n";
	   echo "</tr>\n";
	  }
	  echo "<tr><td><div style='display:block; height:0px;'><!-- --></div></td></tr>\n";
	
    echo "</table>\n";  // end of folder content table
    echo "<!-- end of folder content table $servername -->\n" ;
    echo "</div>\n";
    echo "</td></tr>\n";
    echo "</table>\n";  // end of folder table
    echo "<!-- end of folder table $servername -->\n" ;
	 }
	
   echo "</table>\n";  // end of server content table
   echo "<!-- end of server content table $servername -->\n" ;
   echo "</div>\n";
   echo "</td></tr>\n";
   echo "</table>\n";  // end of server table
   echo "</td></tr>\n";
   echo "<!-- end of server table $servername -->\n" ;
  }

echo "</table>\n";
?>
</form>
</div>
<!-- End of Timer display -->
<?php include "timer_edit.php" ; ?>

</body>
</html>

<?PHP

// Functions
function date_list() {
global $number_days;

for($i=0; $i<=$number_days; $i++)
{
 $today = strtotime("+$i day");
 echo "<option value='".strftime("%Y-%m-%d",$today)."'>".strftime("%a %b %d",$today)."</option>\n";
}
}

function channel_list() {
global $chn_names;

foreach($chn_names as $index => $channel)
{
 echo "<option value='$channel'>$channel</option>\n";
}
}

// fix any wayward characters and trim the result
function fix_chars($input)
{
 //$input = str_replace("'","_",$input) ; 
 $input = str_replace("\\","",$input) ;
 $input = str_replace("","-",$input) ; 
 $input = str_replace("ü","u",$input) ;
 return trim($input) ;
}

?>

